package com.eneraptor.hci

class HciLogicCommService {

    static transactional = true

    Map getReplyToRequest(String requestContent) {
		
		Map reply = new HashMap()
		
		Socket logicSocket = null;
		PrintWriter toLogic = null;
		BufferedReader fromLogic = null;
		
		def ipAddress = InternalConfig.findByConfigId("logic-ip")['configVal']
		def portNum = InternalConfig.findByConfigId("logic-port")['configVal']

		try {
			logicSocket = new Socket(ipAddress, portNum as int);
			toLogic = new PrintWriter(logicSocket.getOutputStream(), true);
			fromLogic = new BufferedReader(new InputStreamReader(
										logicSocket.getInputStream()));
		} catch (UnknownHostException e) {
			reply['status'] = "error"
			reply['content'] = "Unknown host: "
			reply['content'] += e.getMessage()
			return reply
		} catch (IOException e) {
			reply['status'] = "error"
			reply['content'] += e.getMessage()
			return reply
		}
		
		reply['status'] = "ok"
		reply['content'] = ""
		toLogic.println(requestContent)
		List allLines = new ArrayList()
		allLines = fromLogic.readLines()
		allLines.each {
			reply['content'] += it.toString() + "\n"
		}
		
		return reply

    }
	
}
